<template>
  <v-container grid-list-md>
    <v-layout row wrap>
      <v-flex lg4>
        <v-card>
          <v-card-title class='headline'>Planted</v-card-title>
          <v-flex v-for='plant in planted' :key='plant.name'>
            <v-card color='grey lighten-3'>
              <v-card-text>
                <h4>Name:</h4> {{plant.name}}<br/><br/>
                <h4>Info:</h4> {{plant.info}}<br/><br/>
                <h4>Date Planted:</h4> {{plant.date}}/{{plant.month}}
              </v-card-text>
            </v-card>
          </v-flex>
        </v-card>
      </v-flex>
      <v-flex lg4>
        <v-card>
          <v-card-title class='headline'>To Harvest</v-card-title>
          <v-flex v-for='plant in harvest' :key='plant.name'>
            <v-card color='grey lighten-3'>
              <v-card-text>
                <h4>Name:</h4> {{plant.name}}<br/><br/>
                <h4>Info:</h4> {{plant.info}}<br/><br/>
                <h4>Date Planted:</h4> {{plant.date}}/{{plant.month}}
              </v-card-text>
            </v-card>
          </v-flex>
        </v-card>
      </v-flex>
      <v-flex lg4>
        <v-card class='mb-2'>
          <v-card-title class='headline'>To Do</v-card-title>
          <v-card-text>
            <v-flex v-for='todo in todos' :key='todo.text'>
              <v-checkbox v-model='todo.done' :label='todo.text' v-on:change='checkboxUpdate(todo.timestamp, todo.done)'></v-checkbox>
            </v-flex>
          </v-card-text>
        </v-card>
        <v-card>
          <v-card-title class='headline'>Notes</v-card-title>
          <v-flex v-for='note in notes' :key='note.title'>
            <v-card color='grey lighten-3'>
              <v-card-text>
                <h4>{{note.title}}</h4>
                {{note.text}}
              </v-card-text>
            </v-card>
          </v-flex>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import plant from '~/assets/js/plant.js'
import todo from '~/assets/js/todo.js'
import note from '~/assets/js/note.js'

export default {
  props: ['month'],
  data () {
    return {
      planted: [],
      harvest: [],
      todos: [],
      notes: []
    }
  },
  methods: {
    async getMonthPlants () {
      try {
        var plantObject = await plant.getMonthPlants(this)
        for (var key in plantObject) {
          this.planted.push(plantObject[key])
        }
      } catch (e) {
        console.log(e)
      }
    },
    async getHarvestPlants () {
      try {
        var plantObject = await plant.getHarvestPlants(this)
        for (var key in plantObject) {
          this.harvest.push(plantObject[key])
        }
      } catch (e) {
        console.log(e)
      }
    },
    async getTodos () {
      try {
        var todoObject = await todo.getTodos(this)
        for (var key in todoObject) {
          this.todos.push(todoObject[key])
        }
      } catch (e) {
        console.log(e)
      }
    },
    async getNotes () {
      try {
        var noteObject = await note.getNotes(this)
        for (var key in noteObject) {
          this.notes.push(noteObject[key])
        }
      } catch (e) {
        console.log(e)
      }
    },
    checkboxUpdate (timestamp, done) {
      console.log(1)
      todo.update(this, timestamp, done)
    }
  },
  mounted () {
    this.getMonthPlants()
    this.getHarvestPlants()
    this.getTodos()
    this.getNotes()
  }
}
</script>